var gIndividualPurchaseButtonIDs = null;
var gFamilyPurchaseButtonIDs = null;

function showPriceIncreaseComingSoonMessage() {
    $('#PriceIncreaseComingSoonMessage').show();
}

// Tap handlers

function handleShowFeatureDetails(featureTemplate, featureName) {
  sendAction('show-feature-details', {featureTemplate: featureTemplate, featureName: featureName});
}

// Purchase Buttons

function updatePurchaseButtons(state) {
  var ALSubscriptionPurchaseButtonStateLoading = 0;
  var ALSubscriptionPurchaseButtonStateReady = 1;
  var ALSubscriptionPurchaseButtonStatePurchasingIndividual = 2;
  var ALSubscriptionPurchaseButtonStatePurchasingFamily = 3;

  var buttonState = state.buttonState;

  var individualPurchaseButton = $('.IndividualPurchaseButton');
  var familyPurchaseButton = $('.FamilyPurchaseButton');

  var allButtonPurchaseIDs = $.merge( $.merge( [], gIndividualPurchaseButtonIDs ), gFamilyPurchaseButtonIDs );
  $.each(allButtonPurchaseIDs, function( index, id ) {
    clickable.setEnabled(id, false);
  });

  if (buttonState == ALSubscriptionPurchaseButtonStateLoading) {
    individualPurchaseButton.html('<div class="PurchaseButton-Loading">Loading&hellip;</div>');
    familyPurchaseButton.html('<div class="PurchaseButton-Loading">Loading&hellip;</div>');
  }
  else if (buttonState == ALSubscriptionPurchaseButtonStateReady) {
    var priceString;
    if (state.introductoryIndividualPrice) {
        priceString = state.introductoryIndividualPrice + ' first year, then<br/>' + state.individualPrice + ' per year';
        individualPurchaseButton.height("70");
    }
    else {
        if (state.individualPrice) {
          priceString = state.individualPrice + ' per year';
        }
        else {
          priceString = '1 year';
        }
        individualPurchaseButton.height("55");
    }
    individualPurchaseButton.html('<div class="SubscriptionType">Buy Individual</div><div class="SubscriptionPrice">' +priceString + '</div>');

    if (state.introductoryFamilyPrice) {
        priceString = state.introductoryFamilyPrice + ' first year, then<br/>' + state.familyPrice + ' per year';
        familyPurchaseButton.height("70");
    } else {
        if (state.familyPrice) {
          priceString = state.familyPrice + ' per year';
        }
        else {
          priceString = '1 year';
        }
        familyPurchaseButton.height("55");
    }
    familyPurchaseButton.html('<div class="SubscriptionType">Buy Household</div><div class="SubscriptionPrice">' + priceString + '</div>');

    $.each(allButtonPurchaseIDs, function( index, id ) {
      clickable.setEnabled(id, true);
    });
  }
  else if (buttonState == ALSubscriptionPurchaseButtonStatePurchasingFamily) {
    familyPurchaseButton.html('<div class="PurchaseButton-Loading">Purchasing&hellip;</div>');
  }
  else if (buttonState == ALSubscriptionPurchaseButtonStatePurchasingIndividual) {
    individualPurchaseButton.html('<div class="PurchaseButton-Loading">Purchasing&hellip;</div>');
  }
}

// Initialization

$(document).ready(function() {
  gIndividualPurchaseButtonIDs = clickable.installClickablesForCSSSelector('.IndividualPurchaseButton');
  gFamilyPurchaseButtonIDs = clickable.installClickablesForCSSSelector('.FamilyPurchaseButton');

  clickable.installClickablesForCSSSelector('.TableCell tr');
  clickable.installClickablesForCSSSelector('.TeamSection');
  clickable.installClickablesForCSSSelector('.Button');

  updatePurchaseButtons({buttonState:0}); // default buttons to "Loading..." state
  sendAction('update-purchase-buttons');
});
